/* A Bison parser, made by GNU Bison 1.875b.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_FNORD = 258,
     TOK_FILE = 259,
     TOK_APPINFO = 260,
     TOK_SORTINFO = 261,
     TOK_RECORD = 262,
     TOK_BEGIN = 263,
     TOK_END = 264,
     TOK_USER_ERROR = 265,
     TOK_USER_WARNING = 266,
     TOK_USER_MESSAGE = 267,
     TOK_FILENAME = 268,
     TOK_ATTRIB = 269,
     TOK_VERSION = 270,
     TOK_CREATION_DATE = 271,
     TOK_MODIFICATION_DATE = 272,
     TOK_BACKUP_DATE = 273,
     TOK_MODIFICATION = 274,
     TOK_TYPEID = 275,
     TOK_CREATORID = 276,
     TOK_UNIQUEID_SEED = 277,
     TOK_RESOURCE = 278,
     TOK_READONLY = 279,
     TOK_DIRTY = 280,
     TOK_BACKUP = 281,
     TOK_NEWER = 282,
     TOK_RESET = 283,
     TOK_NOBEAM = 284,
     TOK_STREAM = 285,
     TOK_HIDDEN = 286,
     TOK_LAUNCHABLE = 287,
     TOK_RECYCLABLE = 288,
     TOK_BUNDLE = 289,
     TOK_NOW = 290,
     TOK_TODAY = 291,
     TOK_RECORDID = 292,
     TOK_ID = 293,
     TOK_SECRET = 294,
     TOK_BUSY = 295,
     TOK_DELETE = 296,
     TOK_CATEGORY = 297,
     TOK_BIN = 298,
     TOK_OCT = 299,
     TOK_DEC = 300,
     TOK_HEX = 301,
     TOK_BASE = 302,
     TOK_BYTE = 303,
     TOK_WORD = 304,
     TOK_LONG = 305,
     TOK_SIZE = 306,
     TOK_PADSTRING = 307,
     TOK_PADCHAR = 308,
     TOK_DOUBLE = 309,
     TOK_FLOAT = 310,
     TOK_SIGNED = 311,
     TOK_UNSIGNED = 312,
     TOK_OP_EQUAL = 313,
     TOK_OP_UNEQUAL = 314,
     TOK_OP_LT = 315,
     TOK_OP_LE = 316,
     TOK_OP_GT = 317,
     TOK_OP_GE = 318,
     TOK_OP_SHL = 319,
     TOK_OP_SHR = 320,
     TOK_MAYBE_HEXNUMBER = 321,
     TOK_REALNUMBER = 322,
     TOK_DOUBLENUMBER = 323,
     TOK_FLOATNUMBER = 324,
     TOK_BINNUMBER = 325,
     TOK_OCTNUMBER = 326,
     TOK_DECNUMBER = 327,
     TOK_HEXNUMBER = 328,
     TOK_STRING = 329,
     TOK_CHAR = 330,
     TOK_DATE = 331
   };
#endif
#define TOK_FNORD 258
#define TOK_FILE 259
#define TOK_APPINFO 260
#define TOK_SORTINFO 261
#define TOK_RECORD 262
#define TOK_BEGIN 263
#define TOK_END 264
#define TOK_USER_ERROR 265
#define TOK_USER_WARNING 266
#define TOK_USER_MESSAGE 267
#define TOK_FILENAME 268
#define TOK_ATTRIB 269
#define TOK_VERSION 270
#define TOK_CREATION_DATE 271
#define TOK_MODIFICATION_DATE 272
#define TOK_BACKUP_DATE 273
#define TOK_MODIFICATION 274
#define TOK_TYPEID 275
#define TOK_CREATORID 276
#define TOK_UNIQUEID_SEED 277
#define TOK_RESOURCE 278
#define TOK_READONLY 279
#define TOK_DIRTY 280
#define TOK_BACKUP 281
#define TOK_NEWER 282
#define TOK_RESET 283
#define TOK_NOBEAM 284
#define TOK_STREAM 285
#define TOK_HIDDEN 286
#define TOK_LAUNCHABLE 287
#define TOK_RECYCLABLE 288
#define TOK_BUNDLE 289
#define TOK_NOW 290
#define TOK_TODAY 291
#define TOK_RECORDID 292
#define TOK_ID 293
#define TOK_SECRET 294
#define TOK_BUSY 295
#define TOK_DELETE 296
#define TOK_CATEGORY 297
#define TOK_BIN 298
#define TOK_OCT 299
#define TOK_DEC 300
#define TOK_HEX 301
#define TOK_BASE 302
#define TOK_BYTE 303
#define TOK_WORD 304
#define TOK_LONG 305
#define TOK_SIZE 306
#define TOK_PADSTRING 307
#define TOK_PADCHAR 308
#define TOK_DOUBLE 309
#define TOK_FLOAT 310
#define TOK_SIGNED 311
#define TOK_UNSIGNED 312
#define TOK_OP_EQUAL 313
#define TOK_OP_UNEQUAL 314
#define TOK_OP_LT 315
#define TOK_OP_LE 316
#define TOK_OP_GT 317
#define TOK_OP_GE 318
#define TOK_OP_SHL 319
#define TOK_OP_SHR 320
#define TOK_MAYBE_HEXNUMBER 321
#define TOK_REALNUMBER 322
#define TOK_DOUBLENUMBER 323
#define TOK_FLOATNUMBER 324
#define TOK_BINNUMBER 325
#define TOK_OCTNUMBER 326
#define TOK_DECNUMBER 327
#define TOK_HEXNUMBER 328
#define TOK_STRING 329
#define TOK_CHAR 330
#define TOK_DATE 331




/* Copy the first part of user declarations.  */
#line 1 "parser.y"


//--------------------------------------------------------------------
//
// Copyright 2001 by Eric Obermuhlner
//
// $Id: parser.c,v 1.2 2004/04/28 15:00:38 eobermuhlner Exp eobermuhlner $
//
// $Log: parser.c,v $
// Revision 1.2  2004/04/28 15:00:38  eobermuhlner
// ready for 0.9.5
//
// Revision 1.5  2001/11/21 22:22:38  obermuhl
// resource block uses begin_resource()/end_resource()
// use TOK_ID for resources (with decimal value)
//
// Revision 1.4  2001/11/17 11:26:44  obermuhl
// impl resources
//
// Revision 1.3  2001/11/12 23:00:29  obermuhl
// added resource,stream,hidden (fileheader attributes)
//
// Revision 1.2  2001/11/02 21:31:24  obermuhl
// added keywords 'double' and 'float' to handle default real values
//
// Revision 1.1  2001/09/30 10:58:36  obermuhl
// Initial revision
//
//
//---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef WIN32
#include <malloc.h>
#endif

#include "pdbc.h"
#include "error.h"
#include "comperror.h"

#define YYDEBUG 1
//#define YYERROR_VERBOSE

int yylex();
void yyrestart(FILE *input_file);
void yyerror(char *msg);
extern char *yytext;

int get_linenumber();
extern int lineno;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 53 "parser.y"
typedef union YYSTYPE {
unsigned long lval;
double dval;
float fval;
char *sval;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 287 "parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 299 "parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   312

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  95
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  90
/* YYNRULES -- Number of rules. */
#define YYNRULES  206
/* YYNRULES -- Number of states. */
#define YYNSTATES  327

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   331

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    93,     2,     2,     2,    92,    89,     2,
      84,    85,    90,    82,     2,    86,     2,    91,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    83,    77,
       2,    78,     2,    87,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    88,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    79,    81,    80,    94,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     6,     7,     8,    18,    20,    23,
      24,    25,    31,    32,    38,    39,    45,    46,    52,    53,
      59,    60,    66,    67,    73,    74,    80,    81,    87,    88,
      94,    96,    98,   100,   102,   104,   111,   113,   115,   116,
     120,   124,   126,   128,   130,   132,   134,   136,   138,   140,
     142,   144,   146,   148,   150,   152,   154,   156,   158,   161,
     163,   165,   171,   174,   175,   177,   179,   181,   183,   184,
     189,   190,   195,   196,   202,   203,   209,   212,   213,   214,
     220,   221,   227,   229,   231,   233,   234,   238,   242,   244,
     246,   248,   250,   252,   254,   259,   261,   267,   269,   272,
     273,   274,   280,   281,   287,   289,   291,   293,   298,   300,
     301,   306,   309,   310,   312,   314,   316,   318,   320,   322,
     324,   326,   328,   330,   332,   334,   336,   338,   339,   345,
     347,   349,   351,   352,   358,   359,   365,   366,   372,   374,
     376,   378,   381,   384,   386,   388,   390,   392,   394,   398,
     400,   402,   408,   410,   414,   416,   420,   422,   426,   428,
     432,   436,   438,   442,   446,   450,   454,   456,   460,   464,
     466,   470,   474,   476,   480,   484,   488,   490,   493,   496,
     499,   502,   504,   506,   510,   512,   514,   516,   518,   520,
     522,   524,   526,   528,   530,   532,   534,   536,   538,   540,
     542,   544,   546,   548,   550,   553,   556
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      96,     0,    -1,    97,    -1,    -1,    -1,    -1,     4,    98,
     101,     8,    99,   122,     9,   100,    77,    -1,   102,    -1,
     102,   103,    -1,    -1,    -1,    13,    78,   114,   104,    77,
      -1,    -1,    14,    78,   116,   105,    77,    -1,    -1,    15,
      78,   175,   106,    77,    -1,    -1,    16,    78,   119,   107,
      77,    -1,    -1,    17,    78,   119,   108,    77,    -1,    -1,
      18,    78,   119,   109,    77,    -1,    -1,    19,    78,   175,
     110,    77,    -1,    -1,    20,    78,   115,   111,    77,    -1,
      -1,    21,    78,   115,   112,    77,    -1,    -1,    22,    78,
     175,   113,    77,    -1,    77,    -1,   184,    -1,    74,    -1,
      75,    -1,   175,    -1,    79,   175,   175,   175,   175,    80,
      -1,   182,    -1,   117,    -1,    -1,   117,    81,   118,    -1,
     117,    82,   118,    -1,   118,    -1,   175,    -1,    23,    -1,
      24,    -1,    25,    -1,    26,    -1,    27,    -1,    28,    -1,
      29,    -1,    30,    -1,    31,    -1,    32,    -1,    33,    -1,
      34,    -1,   175,    -1,    35,    -1,   120,    -1,   120,   121,
      -1,    76,    -1,    36,    -1,   174,    83,   174,    83,   174,
      -1,   122,   123,    -1,    -1,   124,    -1,   126,    -1,   128,
      -1,   130,    -1,    -1,     5,   125,   145,    77,    -1,    -1,
       6,   127,   145,    77,    -1,    -1,     7,   129,   132,   145,
      77,    -1,    -1,    23,   131,   140,   145,    77,    -1,   132,
     133,    -1,    -1,    -1,    14,    78,   136,   134,    77,    -1,
      -1,    37,    78,   139,   135,    77,    -1,    77,    -1,   184,
      -1,   137,    -1,    -1,   137,    81,   138,    -1,   137,    82,
     138,    -1,   138,    -1,   175,    -1,    39,    -1,    40,    -1,
      25,    -1,    41,    -1,    42,    84,   174,    85,    -1,   175,
      -1,    79,   175,   175,   175,    80,    -1,   182,    -1,   140,
     141,    -1,    -1,    -1,    20,    78,   115,   142,    77,    -1,
      -1,    38,    78,   144,   143,    77,    -1,    77,    -1,   184,
      -1,   174,    -1,    79,   175,   175,    80,    -1,   182,    -1,
      -1,     8,   146,   147,     9,    -1,   147,   148,    -1,    -1,
     149,    -1,   145,    -1,   150,    -1,   160,    -1,   184,    -1,
     151,    -1,   153,    -1,   155,    -1,   158,    -1,   159,    -1,
      43,    -1,    44,    -1,    45,    -1,    46,    -1,    -1,    47,
      84,   177,   152,    85,    -1,    48,    -1,    49,    -1,    50,
      -1,    -1,    51,    84,   177,   154,    85,    -1,    -1,    52,
      84,   177,   156,    85,    -1,    -1,    53,    84,   177,   157,
      85,    -1,    54,    -1,    55,    -1,   177,    -1,    82,   177,
      -1,    86,   177,    -1,   178,    -1,   179,    -1,   180,    -1,
     181,    -1,   182,    -1,    84,   161,    85,    -1,   162,    -1,
     163,    -1,   163,    87,   162,    83,   162,    -1,   164,    -1,
     163,    81,   164,    -1,   165,    -1,   164,    88,   165,    -1,
     166,    -1,   165,    89,   166,    -1,   167,    -1,   166,    58,
     167,    -1,   166,    59,   167,    -1,   168,    -1,   167,    60,
     168,    -1,   167,    61,   168,    -1,   167,    62,   168,    -1,
     167,    63,   168,    -1,   169,    -1,   168,    64,   169,    -1,
     168,    65,   169,    -1,   170,    -1,   169,    82,   170,    -1,
     169,    86,   170,    -1,   171,    -1,   170,    90,   171,    -1,
     170,    91,   171,    -1,   170,    92,   171,    -1,   172,    -1,
      93,   171,    -1,    94,   171,    -1,    86,   172,    -1,    82,
     172,    -1,   177,    -1,   173,    -1,    84,   161,    85,    -1,
      66,    -1,   176,    -1,    66,    -1,   176,    -1,    70,    -1,
      71,    -1,    72,    -1,    73,    -1,    66,    -1,    70,    -1,
      71,    -1,    72,    -1,    73,    -1,    67,    -1,    68,    -1,
      69,    -1,    74,    -1,    75,    -1,    74,    -1,    75,    -1,
      10,   183,    -1,    11,   183,    -1,    12,   183,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   204,   204,   209,   212,   215,   208,   221,   225,   226,
     231,   230,   234,   233,   237,   236,   240,   239,   245,   244,
     250,   249,   255,   254,   258,   257,   261,   260,   264,   263,
     266,   267,   271,   272,   276,   278,   280,   285,   288,   292,
     294,   296,   301,   303,   305,   307,   309,   311,   313,   315,
     317,   319,   321,   323,   325,   330,   332,   334,   336,   341,
     343,   348,   353,   354,   358,   359,   360,   361,   366,   365,
     373,   372,   380,   379,   388,   387,   395,   396,   401,   400,
     404,   403,   406,   407,   411,   414,   418,   420,   422,   427,
     429,   431,   433,   435,   437,   442,   444,   446,   451,   452,
     457,   456,   460,   459,   462,   463,   467,   469,   471,   477,
     476,   484,   485,   489,   490,   494,   495,   496,   500,   501,
     502,   503,   504,   508,   510,   512,   514,   517,   516,   522,
     524,   526,   529,   528,   535,   534,   538,   537,   543,   548,
     553,   555,   557,   559,   567,   569,   571,   573,   575,   579,
     583,   585,   589,   591,   595,   597,   601,   603,   607,   609,
     611,   615,   617,   619,   621,   623,   627,   629,   631,   635,
     637,   639,   643,   645,   647,   649,   653,   655,   657,   659,
     661,   664,   666,   670,   675,   677,   682,   684,   689,   691,
     693,   695,   700,   701,   702,   703,   704,   708,   712,   716,
     720,   724,   728,   729,   733,   735,   737
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_FNORD", "TOK_FILE", "TOK_APPINFO", 
  "TOK_SORTINFO", "TOK_RECORD", "TOK_BEGIN", "TOK_END", "TOK_USER_ERROR", 
  "TOK_USER_WARNING", "TOK_USER_MESSAGE", "TOK_FILENAME", "TOK_ATTRIB", 
  "TOK_VERSION", "TOK_CREATION_DATE", "TOK_MODIFICATION_DATE", 
  "TOK_BACKUP_DATE", "TOK_MODIFICATION", "TOK_TYPEID", "TOK_CREATORID", 
  "TOK_UNIQUEID_SEED", "TOK_RESOURCE", "TOK_READONLY", "TOK_DIRTY", 
  "TOK_BACKUP", "TOK_NEWER", "TOK_RESET", "TOK_NOBEAM", "TOK_STREAM", 
  "TOK_HIDDEN", "TOK_LAUNCHABLE", "TOK_RECYCLABLE", "TOK_BUNDLE", 
  "TOK_NOW", "TOK_TODAY", "TOK_RECORDID", "TOK_ID", "TOK_SECRET", 
  "TOK_BUSY", "TOK_DELETE", "TOK_CATEGORY", "TOK_BIN", "TOK_OCT", 
  "TOK_DEC", "TOK_HEX", "TOK_BASE", "TOK_BYTE", "TOK_WORD", "TOK_LONG", 
  "TOK_SIZE", "TOK_PADSTRING", "TOK_PADCHAR", "TOK_DOUBLE", "TOK_FLOAT", 
  "TOK_SIGNED", "TOK_UNSIGNED", "TOK_OP_EQUAL", "TOK_OP_UNEQUAL", 
  "TOK_OP_LT", "TOK_OP_LE", "TOK_OP_GT", "TOK_OP_GE", "TOK_OP_SHL", 
  "TOK_OP_SHR", "TOK_MAYBE_HEXNUMBER", "TOK_REALNUMBER", 
  "TOK_DOUBLENUMBER", "TOK_FLOATNUMBER", "TOK_BINNUMBER", "TOK_OCTNUMBER", 
  "TOK_DECNUMBER", "TOK_HEXNUMBER", "TOK_STRING", "TOK_CHAR", "TOK_DATE", 
  "';'", "'='", "'{'", "'}'", "'|'", "'+'", "':'", "'('", "')'", "'-'", 
  "'?'", "'^'", "'&'", "'*'", "'/'", "'%'", "'!'", "'~'", "$accept", 
  "compilation_unit", "file_decl", "@1", "@2", "@3", "fileheader_decl", 
  "seq_fileheader_settings", "fileheader_settings", "@4", "@5", "@6", 
  "@7", "@8", "@9", "@10", "@11", "@12", "@13", "filename_literal", 
  "id_literal", "seq_file_attrib_flag", "seq_file_attrib_flag1", 
  "file_attrib_flag", "datetime_value", "date_value", "time_value", 
  "seq_chunk_decl", "chunk_decl", "appinfo_decl", "@14", "sortinfo_decl", 
  "@15", "record_decl", "@16", "resource_decl", "@17", 
  "seq_record_setting", "record_setting", "@18", "@19", 
  "seq_record_attrib_flag", "seq_record_attrib_flag1", 
  "record_attrib_flag", "record_id", "seq_resource_setting", 
  "resource_setting", "@20", "@21", "resource_id", "record_block", "@22", 
  "seq_record_data", "record_data", "data", "data_state_command", 
  "data_base_command", "@23", "data_size_command", "@24", 
  "data_pad_command", "@25", "@26", "data_double_command", 
  "data_float_command", "data_value", "expr", "condex", "orex", "xorex", 
  "andex", "eqex", "relex", "shiftex", "arith", "term", "factor", "prim", 
  "nested", "dec_value", "hex_value", "based_value", "long_value", 
  "real_value", "double_value", "float_value", "string_value", 
  "char_value", "string_or_char_value", "user_message", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    59,    61,   123,
     125,   124,    43,    58,    40,    41,    45,    63,    94,    38,
      42,    47,    37,    33,   126
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    95,    96,    98,    99,   100,    97,   101,   102,   102,
     104,   103,   105,   103,   106,   103,   107,   103,   108,   103,
     109,   103,   110,   103,   111,   103,   112,   103,   113,   103,
     103,   103,   114,   114,   115,   115,   115,   116,   116,   117,
     117,   117,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   119,   119,   119,   119,   120,
     120,   121,   122,   122,   123,   123,   123,   123,   125,   124,
     127,   126,   129,   128,   131,   130,   132,   132,   134,   133,
     135,   133,   133,   133,   136,   136,   137,   137,   137,   138,
     138,   138,   138,   138,   138,   139,   139,   139,   140,   140,
     142,   141,   143,   141,   141,   141,   144,   144,   144,   146,
     145,   147,   147,   148,   148,   149,   149,   149,   150,   150,
     150,   150,   150,   151,   151,   151,   151,   152,   151,   153,
     153,   153,   154,   153,   156,   155,   157,   155,   158,   159,
     160,   160,   160,   160,   160,   160,   160,   160,   160,   161,
     162,   162,   163,   163,   164,   164,   165,   165,   166,   166,
     166,   167,   167,   167,   167,   167,   168,   168,   168,   169,
     169,   169,   170,   170,   170,   170,   171,   171,   171,   171,
     171,   172,   172,   173,   174,   174,   175,   175,   176,   176,
     176,   176,   177,   177,   177,   177,   177,   178,   179,   180,
     181,   182,   183,   183,   184,   184,   184
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     0,     0,     0,     9,     1,     2,     0,
       0,     5,     0,     5,     0,     5,     0,     5,     0,     5,
       0,     5,     0,     5,     0,     5,     0,     5,     0,     5,
       1,     1,     1,     1,     1,     6,     1,     1,     0,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     5,     2,     0,     1,     1,     1,     1,     0,     4,
       0,     4,     0,     5,     0,     5,     2,     0,     0,     5,
       0,     5,     1,     1,     1,     0,     3,     3,     1,     1,
       1,     1,     1,     1,     4,     1,     5,     1,     2,     0,
       0,     5,     0,     5,     1,     1,     1,     4,     1,     0,
       4,     2,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     1,
       1,     1,     0,     5,     0,     5,     0,     5,     1,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     3,     1,
       1,     5,     1,     3,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     1,     2,     2,     2,
       2,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     3,     0,     2,     9,     1,     0,     7,     4,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,     8,    31,    63,   202,   203,   204,   205,
     206,     0,    38,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    32,    33,    10,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,   186,   188,   189,
     190,   191,    12,    37,    41,    42,   187,    14,    56,    60,
      59,    16,    57,    55,    18,    20,    22,   201,     0,    24,
      34,    36,    26,    28,    68,    70,    72,     5,    74,    62,
      64,    65,    66,    67,     0,     0,     0,     0,     0,     0,
     184,    58,     0,   185,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    77,     0,    99,    11,    13,    39,    40,
      15,    17,     0,    19,    21,    23,     0,    25,    27,    29,
     109,     0,     0,     0,     6,     0,     0,     0,   112,    69,
      71,     0,     0,    82,    76,     0,    83,     0,     0,   104,
      98,     0,   105,     0,     0,     0,    85,     0,    73,     0,
       0,    75,    61,    35,   110,   123,   124,   125,   126,     0,
     129,   130,   131,     0,     0,     0,   138,   139,   192,   197,
     198,   199,   193,   194,   195,   196,   200,     0,     0,     0,
     114,   111,   113,   115,   118,   119,   120,   121,   122,   116,
     140,   143,   144,   145,   146,   147,   117,    92,    90,    91,
      93,     0,    78,    84,    88,    89,     0,    80,    95,    97,
     100,     0,   102,   106,   108,     0,     0,     0,     0,   141,
       0,     0,     0,     0,     0,     0,   149,   150,   152,   154,
     156,   158,   161,   166,   169,   172,   176,   182,   181,   142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   127,
     132,   134,   136,   180,     0,   179,   177,   178,   148,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    79,    86,    87,
       0,    81,   101,     0,   103,     0,     0,     0,     0,   183,
     153,     0,   155,   157,   159,   160,   162,   163,   164,   165,
     167,   168,   170,   171,   173,   174,   175,    94,     0,   107,
     128,   133,   135,   137,     0,    96,   151
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,     3,     4,    25,   114,     6,     7,    23,    94,
      95,    98,    99,   104,   105,   106,   108,   109,   110,    44,
      79,    62,    63,    64,    71,    72,   101,    41,    89,    90,
     111,    91,   112,    92,   113,    93,   115,   133,   144,   251,
     255,   212,   213,   214,   217,   135,   150,   256,   258,   222,
     131,   138,   155,   191,   192,   193,   194,   295,   195,   296,
     196,   297,   298,   197,   198,   199,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   102,
      65,    66,   248,   201,   202,   203,   204,    81,    28,    24
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -247
static const short yypact[] =
{
      23,  -247,    39,  -247,  -247,  -247,    44,    50,  -247,   -32,
     -32,   -32,   -23,   -21,   -19,    -5,    -1,     3,    14,    16,
      27,    47,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,     1,    88,   198,    62,    62,    62,   198,   162,   162,
     198,   220,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,    -2,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,   206,  -247,  -247,  -247,  -247,  -247,   198,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,    52,    54,    88,    88,    59,    80,
    -247,  -247,   102,  -247,    86,   104,   127,   198,   135,   141,
     153,   190,   190,  -247,   154,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,   206,  -247,  -247,  -247,   198,  -247,  -247,  -247,
    -247,   159,   161,    11,  -247,    18,   123,   198,  -247,  -247,
    -247,   136,   164,  -247,  -247,   171,  -247,   177,   178,  -247,
    -247,   175,  -247,   206,   182,    98,   137,   174,  -247,   162,
     188,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,   155,
    -247,  -247,  -247,   181,   189,   191,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,   214,   129,   214,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,   197,  -247,     5,  -247,  -247,   198,  -247,  -247,  -247,
    -247,   198,  -247,  -247,  -247,   214,   214,   214,   214,  -247,
     121,   129,   121,   129,   129,   211,  -247,   -67,   186,   193,
      32,   228,    38,   -45,   -74,  -247,  -247,  -247,  -247,  -247,
     206,   221,   137,   137,   198,   222,   223,   198,   224,  -247,
    -247,  -247,  -247,  -247,   212,  -247,  -247,  -247,  -247,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   217,  -247,  -247,  -247,
     198,  -247,  -247,   203,  -247,   218,   219,   225,   226,  -247,
     186,   183,   193,    32,   228,   228,    38,    38,    38,    38,
     -45,   -45,   -74,   -74,  -247,  -247,  -247,  -247,   227,  -247,
    -247,  -247,  -247,  -247,   129,  -247,  -247
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
     -29,  -247,  -247,    43,   120,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,   -78,  -247,  -247,  -247,  -247,  -247,  -247,
    -101,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,    74,  -246,  -247,    37,
      41,    36,   -84,    17,   -83,   -65,  -184,  -179,  -247,  -113,
     -33,   -64,  -143,  -247,  -247,  -247,  -247,  -124,   240,  -120
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short yytable[] =
{
      67,    73,    73,    73,    76,    80,    80,    83,   103,   136,
      82,   132,   200,   146,   269,   152,   283,   284,   285,   130,
     270,     9,    10,    11,   301,   141,   130,     1,     9,    10,
      11,   205,   145,   219,   151,   206,   224,   281,   147,     5,
     162,   282,    26,    27,   229,   107,   249,   223,   142,   266,
     267,   263,     8,   265,   190,    31,   148,    32,   103,    33,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    34,   126,    42,    43,    35,   326,    96,
      97,    36,   259,   260,   261,   262,   252,   253,   143,   103,
     273,   274,    37,   137,    38,   149,   103,    68,    69,   314,
     315,   316,   279,   280,   154,    39,   130,   164,     9,    10,
      11,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,   215,   218,    40,    80,    22,    57,   116,
     220,   117,    58,    59,    60,    61,   120,   286,    70,   118,
     119,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,    57,    74,    75,   121,    58,    59,
      60,    61,   207,   123,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    77,   288,   289,   208,   209,   210,   211,
     187,   124,   188,   254,   189,   122,   103,   178,   257,   304,
     305,   182,   183,   184,   185,   178,   310,   311,   130,   182,
     183,   184,   185,    57,   125,   231,   153,    58,    59,    60,
      61,   230,   127,   231,   156,   232,   312,   313,   128,   215,
     215,   290,   233,   234,   293,    84,    85,    86,    57,    87,
     129,   134,    58,    59,    60,    61,   139,    77,   140,   225,
      57,    78,   157,    88,    58,    59,    60,    61,   158,    77,
      29,    30,   161,   216,   100,   159,   160,   318,    58,    59,
      60,    61,   163,    77,    57,   226,   324,   221,    58,    59,
      60,    61,   100,   227,   271,   228,    58,    59,    60,    61,
     178,   250,   272,   319,   182,   183,   184,   185,   275,   276,
     277,   278,   306,   307,   308,   309,   268,   299,   287,   291,
     292,   294,   317,   320,   321,   264,   300,   325,   303,     0,
     322,   323,   302
};

static const short yycheck[] =
{
      33,    34,    35,    36,    37,    38,    39,    40,    72,   122,
      39,   112,   155,   133,    81,   135,    90,    91,    92,     8,
      87,    10,    11,    12,   270,    14,     8,     4,    10,    11,
      12,   155,   133,   157,   135,   155,   160,    82,    20,     0,
     153,    86,    74,    75,   187,    78,   189,   160,    37,   233,
     234,   230,     8,   232,   155,    78,    38,    78,   122,    78,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    78,   107,    74,    75,    78,   324,    81,
      82,    78,   225,   226,   227,   228,    81,    82,    77,   153,
      58,    59,    78,   126,    78,    77,   160,    35,    36,   283,
     284,   285,    64,    65,   137,    78,     8,     9,    10,    11,
      12,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,   156,   157,    78,   159,    77,    66,    77,
     159,    77,    70,    71,    72,    73,    77,   250,    76,    96,
      97,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    66,    35,    36,    77,    70,    71,
      72,    73,    25,    77,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,   252,   253,    39,    40,    41,    42,
      82,    77,    84,   216,    86,    83,   250,    66,   221,   273,
     274,    70,    71,    72,    73,    66,   279,   280,     8,    70,
      71,    72,    73,    66,    77,    84,    83,    70,    71,    72,
      73,    82,    77,    84,    78,    86,   281,   282,    77,   252,
     253,   254,    93,    94,   257,     5,     6,     7,    66,     9,
      77,    77,    70,    71,    72,    73,    77,    75,    77,    84,
      66,    79,    78,    23,    70,    71,    72,    73,    77,    75,
      10,    11,    77,    79,    66,    78,    78,   290,    70,    71,
      72,    73,    80,    75,    66,    84,    83,    79,    70,    71,
      72,    73,    66,    84,    88,    84,    70,    71,    72,    73,
      66,    84,    89,    80,    70,    71,    72,    73,    60,    61,
      62,    63,   275,   276,   277,   278,    85,    85,    77,    77,
      77,    77,    85,    85,    85,   231,   269,    80,   272,    -1,
      85,    85,   271
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     4,    96,    97,    98,     0,   101,   102,     8,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    77,   103,   184,    99,    74,    75,   183,   183,
     183,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      78,   122,    74,    75,   114,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    66,    70,    71,
      72,    73,   116,   117,   118,   175,   176,   175,    35,    36,
      76,   119,   120,   175,   119,   119,   175,    75,    79,   115,
     175,   182,   115,   175,     5,     6,     7,     9,    23,   123,
     124,   126,   128,   130,   104,   105,    81,    82,   106,   107,
      66,   121,   174,   176,   108,   109,   110,   175,   111,   112,
     113,   125,   127,   129,   100,   131,    77,    77,   118,   118,
      77,    77,    83,    77,    77,    77,   175,    77,    77,    77,
       8,   145,   145,   132,    77,   140,   174,   175,   146,    77,
      77,    14,    37,    77,   133,   145,   184,    20,    38,    77,
     141,   145,   184,    83,   175,   147,    78,    78,    77,    78,
      78,    77,   174,    80,     9,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    82,    84,    86,
     145,   148,   149,   150,   151,   153,   155,   158,   159,   160,
     177,   178,   179,   180,   181,   182,   184,    25,    39,    40,
      41,    42,   136,   137,   138,   175,    79,   139,   175,   182,
     115,    79,   144,   174,   182,    84,    84,    84,    84,   177,
      82,    84,    86,    93,    94,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   177,   177,
      84,   134,    81,    82,   175,   135,   142,   175,   143,   177,
     177,   177,   177,   172,   161,   172,   171,   171,    85,    81,
      87,    88,    89,    58,    59,    60,    61,    62,    63,    64,
      65,    82,    86,    90,    91,    92,   174,    77,   138,   138,
     175,    77,    77,   175,    77,   152,   154,   156,   157,    85,
     164,   162,   165,   166,   167,   167,   168,   168,   168,   168,
     169,   169,   170,   170,   171,   171,   171,    85,   175,    80,
      85,    85,    85,    85,    83,    80,   162
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 209 "parser.y"
    { begin_file(); ;}
    break;

  case 4:
#line 212 "parser.y"
    { begin_data(); begin_scope(); ;}
    break;

  case 5:
#line 215 "parser.y"
    { end_scope(); ;}
    break;

  case 6:
#line 217 "parser.y"
    { end_file(); ;}
    break;

  case 10:
#line 231 "parser.y"
    { setFilenameFileHeader(&fileheader, yyvsp[0].sval);  ;}
    break;

  case 12:
#line 234 "parser.y"
    { fileheader.attrib = (unsigned short)(yyvsp[0].lval); ;}
    break;

  case 14:
#line 237 "parser.y"
    { fileheader.version = (unsigned short)(yyvsp[0].lval); ;}
    break;

  case 16:
#line 240 "parser.y"
    { fileheader.creationDate = yyvsp[0].lval; 
		message(3, "creation_date = %lu (%08x_x)", yyvsp[0].lval, yyvsp[0].lval); 
		;}
    break;

  case 18:
#line 245 "parser.y"
    { fileheader.modificationDate = yyvsp[0].lval; 
		message(3, "modification_date = %lu (%08x_x)", yyvsp[0].lval, yyvsp[0].lval); 
		;}
    break;

  case 20:
#line 250 "parser.y"
    { fileheader.backupDate = yyvsp[0].lval; 
		message(3, "backup_date = %lu (%08x_x)", yyvsp[0].lval, yyvsp[0].lval); 
		;}
    break;

  case 22:
#line 255 "parser.y"
    { fileheader.modNumber = yyvsp[0].lval; ;}
    break;

  case 24:
#line 258 "parser.y"
    { setTypeIdFileHeader(&fileheader, yyvsp[0].lval);  ;}
    break;

  case 26:
#line 261 "parser.y"
    { setCreatorIdFileHeader(&fileheader, yyvsp[0].lval);  ;}
    break;

  case 28:
#line 264 "parser.y"
    { fileheader.uniqueIdSeed = yyvsp[0].lval; ;}
    break;

  case 34:
#line 277 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 35:
#line 279 "parser.y"
    { yyval.lval = conv_4long_to_id(yyvsp[-4].lval, yyvsp[-3].lval, yyvsp[-2].lval, yyvsp[-1].lval);  ;}
    break;

  case 36:
#line 281 "parser.y"
    { yyval.lval = conv_quoted_string_to_id(yyvsp[0].sval, 4);  ;}
    break;

  case 37:
#line 286 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 38:
#line 288 "parser.y"
    { yyval.lval = 0x0000; ;}
    break;

  case 39:
#line 293 "parser.y"
    { yyval.lval = yyvsp[-2].lval | yyvsp[0].lval; ;}
    break;

  case 40:
#line 295 "parser.y"
    { yyval.lval = yyvsp[-2].lval + yyvsp[0].lval; ;}
    break;

  case 41:
#line 297 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 42:
#line 302 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 43:
#line 304 "parser.y"
    { yyval.lval = 0x0001; ;}
    break;

  case 44:
#line 306 "parser.y"
    { yyval.lval = 0x0002; ;}
    break;

  case 45:
#line 308 "parser.y"
    { yyval.lval = 0x0004; ;}
    break;

  case 46:
#line 310 "parser.y"
    { yyval.lval = 0x0008; ;}
    break;

  case 47:
#line 312 "parser.y"
    { yyval.lval = 0x0010; ;}
    break;

  case 48:
#line 314 "parser.y"
    { yyval.lval = 0x0020; ;}
    break;

  case 49:
#line 316 "parser.y"
    { yyval.lval = 0x0040; ;}
    break;

  case 50:
#line 318 "parser.y"
    { yyval.lval = 0x0080; ;}
    break;

  case 51:
#line 320 "parser.y"
    { yyval.lval = 0x0100; ;}
    break;

  case 52:
#line 322 "parser.y"
    { yyval.lval = 0x0200; ;}
    break;

  case 53:
#line 324 "parser.y"
    { yyval.lval = 0x0400; ;}
    break;

  case 54:
#line 326 "parser.y"
    { yyval.lval = 0x0800; ;}
    break;

  case 55:
#line 331 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 56:
#line 333 "parser.y"
    { yyval.lval = get_now(); ;}
    break;

  case 57:
#line 335 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 58:
#line 337 "parser.y"
    { yyval.lval = yyvsp[-1].lval + yyvsp[0].lval; ;}
    break;

  case 59:
#line 342 "parser.y"
    { int y,m,d; sscanf(yyvsp[0].sval, "%d/%d/%d", &y, &m, &d); yyval.lval = get_date(y,m,d); ;}
    break;

  case 60:
#line 344 "parser.y"
    { yyval.lval = get_today(); ;}
    break;

  case 61:
#line 349 "parser.y"
    { yyval.lval = (yyvsp[-4].lval*60 + yyvsp[-2].lval)*60 + yyvsp[0].lval; ;}
    break;

  case 68:
#line 366 "parser.y"
    { begin_appinfo(); ;}
    break;

  case 69:
#line 368 "parser.y"
    { end_appinfo(); ;}
    break;

  case 70:
#line 373 "parser.y"
    { begin_sortinfo(); ;}
    break;

  case 71:
#line 375 "parser.y"
    { end_sortinfo(); ;}
    break;

  case 72:
#line 380 "parser.y"
    { begin_record(); ;}
    break;

  case 73:
#line 383 "parser.y"
    { end_record(); ;}
    break;

  case 74:
#line 388 "parser.y"
    { begin_resource(); ;}
    break;

  case 75:
#line 391 "parser.y"
    { end_resource(); ;}
    break;

  case 78:
#line 401 "parser.y"
    { set_record_attrib((char) yyvsp[0].lval); ;}
    break;

  case 80:
#line 404 "parser.y"
    { set_record_id(yyvsp[0].lval); ;}
    break;

  case 84:
#line 412 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 85:
#line 414 "parser.y"
    { yyval.lval = 0x00; ;}
    break;

  case 86:
#line 419 "parser.y"
    { yyval.lval = yyvsp[-2].lval | yyvsp[0].lval; ;}
    break;

  case 87:
#line 421 "parser.y"
    { yyval.lval = yyvsp[-2].lval + yyvsp[0].lval; ;}
    break;

  case 88:
#line 423 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 89:
#line 428 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 90:
#line 430 "parser.y"
    { yyval.lval = 0x10; ;}
    break;

  case 91:
#line 432 "parser.y"
    { yyval.lval = 0x20; ;}
    break;

  case 92:
#line 434 "parser.y"
    { yyval.lval = 0x40; ;}
    break;

  case 93:
#line 436 "parser.y"
    { yyval.lval = 0x80; ;}
    break;

  case 94:
#line 438 "parser.y"
    { yyval.lval = yyvsp[-1].lval; ;}
    break;

  case 95:
#line 443 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 96:
#line 445 "parser.y"
    { yyval.lval = conv_4long_to_id(0, yyvsp[-3].lval, yyvsp[-2].lval, yyvsp[-1].lval); ;}
    break;

  case 97:
#line 447 "parser.y"
    { yyval.lval = conv_quoted_string_to_id(yyvsp[0].sval, 3); ;}
    break;

  case 100:
#line 457 "parser.y"
    { set_resource_type_id(yyvsp[0].lval); ;}
    break;

  case 102:
#line 460 "parser.y"
    { set_resource_id((unsigned short)yyvsp[0].lval); ;}
    break;

  case 106:
#line 468 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 107:
#line 470 "parser.y"
    { yyval.lval = conv_4long_to_id(0, 0, yyvsp[-2].lval, yyvsp[-1].lval); ;}
    break;

  case 108:
#line 472 "parser.y"
    { yyval.lval = conv_quoted_string_to_id(yyvsp[0].sval, 2); ;}
    break;

  case 109:
#line 477 "parser.y"
    { begin_scope(); ;}
    break;

  case 110:
#line 480 "parser.y"
    { end_scope(); ;}
    break;

  case 123:
#line 509 "parser.y"
    { set_base(2); ;}
    break;

  case 124:
#line 511 "parser.y"
    { set_base(8); ;}
    break;

  case 125:
#line 513 "parser.y"
    { set_base(10); ;}
    break;

  case 126:
#line 515 "parser.y"
    { set_base(16); ;}
    break;

  case 127:
#line 517 "parser.y"
    { set_base(conv_str_to_ulong(yyvsp[0].sval, 10)); ;}
    break;

  case 129:
#line 523 "parser.y"
    { set_size(1); ;}
    break;

  case 130:
#line 525 "parser.y"
    { set_size(2); ;}
    break;

  case 131:
#line 527 "parser.y"
    { set_size(4); ;}
    break;

  case 132:
#line 529 "parser.y"
    { set_size(conv_str_to_ulong(yyvsp[0].sval, 10)); ;}
    break;

  case 134:
#line 535 "parser.y"
    { set_padstring(conv_str_to_ulong(yyvsp[0].sval, 10)); ;}
    break;

  case 136:
#line 538 "parser.y"
    { set_padchar(conv_str_to_ulong(yyvsp[0].sval, 10)); ;}
    break;

  case 138:
#line 544 "parser.y"
    { set_double_mode(1); ;}
    break;

  case 139:
#line 549 "parser.y"
    { set_double_mode(0); ;}
    break;

  case 140:
#line 554 "parser.y"
    { write_number(yyvsp[0].sval, 1, get_base(), get_size()); ;}
    break;

  case 141:
#line 556 "parser.y"
    { write_number(yyvsp[0].sval, 1, get_base(), get_size()); ;}
    break;

  case 142:
#line 558 "parser.y"
    { write_number(yyvsp[0].sval, 0, get_base(), get_size()); ;}
    break;

  case 143:
#line 560 "parser.y"
    { 
		  if(get_double_mode()) {
		    write_double(yyvsp[0].dval); 
		  } else {
		    write_float((float)yyvsp[0].dval); 
		  }
		;}
    break;

  case 144:
#line 568 "parser.y"
    { write_double(yyvsp[0].dval); ;}
    break;

  case 145:
#line 570 "parser.y"
    { write_float(yyvsp[0].fval); ;}
    break;

  case 146:
#line 572 "parser.y"
    { write_quoted_string(yyvsp[0].sval, get_padstring(), TRUE); ;}
    break;

  case 147:
#line 574 "parser.y"
    { write_quoted_string(yyvsp[0].sval, get_padchar(), FALSE); ;}
    break;

  case 148:
#line 576 "parser.y"
    { write_value(yyvsp[-1].lval, 1, get_size()); ;}
    break;

  case 149:
#line 580 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 150:
#line 584 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 151:
#line 586 "parser.y"
    { yyval.lval = yyvsp[-4].lval ? yyvsp[-2].lval : yyvsp[0].lval; ;}
    break;

  case 152:
#line 590 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 153:
#line 592 "parser.y"
    { yyval.lval = yyvsp[-2].lval | yyvsp[0].lval; ;}
    break;

  case 154:
#line 596 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 155:
#line 598 "parser.y"
    { yyval.lval = yyvsp[-2].lval ^ yyvsp[0].lval; ;}
    break;

  case 156:
#line 602 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 157:
#line 604 "parser.y"
    { yyval.lval = yyvsp[-2].lval & yyvsp[0].lval; ;}
    break;

  case 158:
#line 608 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 159:
#line 610 "parser.y"
    { yyval.lval = yyvsp[-2].lval == yyvsp[0].lval; ;}
    break;

  case 160:
#line 612 "parser.y"
    { yyval.lval = yyvsp[-2].lval != yyvsp[0].lval; ;}
    break;

  case 161:
#line 616 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 162:
#line 618 "parser.y"
    { yyval.lval = yyvsp[-2].lval < yyvsp[0].lval; ;}
    break;

  case 163:
#line 620 "parser.y"
    { yyval.lval = yyvsp[-2].lval <= yyvsp[0].lval; ;}
    break;

  case 164:
#line 622 "parser.y"
    { yyval.lval = yyvsp[-2].lval > yyvsp[0].lval; ;}
    break;

  case 165:
#line 624 "parser.y"
    { yyval.lval = yyvsp[-2].lval >= yyvsp[0].lval; ;}
    break;

  case 166:
#line 628 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 167:
#line 630 "parser.y"
    { yyval.lval = yyvsp[-2].lval << yyvsp[0].lval; ;}
    break;

  case 168:
#line 632 "parser.y"
    { yyval.lval = yyvsp[-2].lval >> yyvsp[0].lval; ;}
    break;

  case 169:
#line 636 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 170:
#line 638 "parser.y"
    { yyval.lval = yyvsp[-2].lval + yyvsp[0].lval; ;}
    break;

  case 171:
#line 640 "parser.y"
    { yyval.lval = yyvsp[-2].lval - yyvsp[0].lval; ;}
    break;

  case 172:
#line 644 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 173:
#line 646 "parser.y"
    { yyval.lval = yyvsp[-2].lval * yyvsp[0].lval; ;}
    break;

  case 174:
#line 648 "parser.y"
    { yyval.lval = yyvsp[-2].lval / yyvsp[0].lval; ;}
    break;

  case 175:
#line 650 "parser.y"
    { yyval.lval = yyvsp[-2].lval % yyvsp[0].lval; ;}
    break;

  case 176:
#line 654 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 177:
#line 656 "parser.y"
    { yyval.lval = ! yyvsp[0].lval; ;}
    break;

  case 178:
#line 658 "parser.y"
    { yyval.lval = ~ yyvsp[0].lval; ;}
    break;

  case 179:
#line 660 "parser.y"
    { yyval.lval = - yyvsp[0].lval; ;}
    break;

  case 180:
#line 662 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 181:
#line 665 "parser.y"
    { yyval.lval = conv_str_to_ulong(yyvsp[0].sval, get_base()); ;}
    break;

  case 182:
#line 667 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 183:
#line 671 "parser.y"
    { yyval.lval = yyvsp[-1].lval; ;}
    break;

  case 184:
#line 676 "parser.y"
    { yyval.lval = conv_str_to_ulong(yyvsp[0].sval, 10); ;}
    break;

  case 185:
#line 678 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 186:
#line 683 "parser.y"
    { yyval.lval = conv_str_to_ulong(yyvsp[0].sval, 16); ;}
    break;

  case 187:
#line 685 "parser.y"
    { yyval.lval = yyvsp[0].lval; ;}
    break;

  case 188:
#line 690 "parser.y"
    { yyvsp[0].sval[strlen(yyvsp[0].sval)-2] = 0; yyval.lval = conv_str_to_ulong(yyvsp[0].sval, 2); ;}
    break;

  case 189:
#line 692 "parser.y"
    { yyvsp[0].sval[strlen(yyvsp[0].sval)-2] = 0; yyval.lval = conv_str_to_ulong(yyvsp[0].sval, 8); ;}
    break;

  case 190:
#line 694 "parser.y"
    { yyvsp[0].sval[strlen(yyvsp[0].sval)-2] = 0; yyval.lval = conv_str_to_ulong(yyvsp[0].sval, 10); ;}
    break;

  case 191:
#line 696 "parser.y"
    { yyvsp[0].sval[strlen(yyvsp[0].sval)-2] = 0; yyval.lval = conv_str_to_ulong(yyvsp[0].sval, 16); ;}
    break;

  case 204:
#line 734 "parser.y"
    { compiler_error("User error: %s", yyvsp[0].sval); ;}
    break;

  case 205:
#line 736 "parser.y"
    { compiler_warning("User warning: %s", yyvsp[0].sval); ;}
    break;

  case 206:
#line 738 "parser.y"
    { message(1, "User message: %s", yyvsp[0].sval); ;}
    break;


    }

/* Line 999 of yacc.c.  */
#line 2239 "parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 741 "parser.y"


void yyerror(char *msg)
{
  compiler_error("%s '%s'", 
	msg, yytext);
}

void begin_parser(FILE *in)
{
  yyrestart(in);
  lineno = 1;
  
//  BEGIN INITIAL;

  yyparse();
}

