#ifndef BISON_PARSER_H
# define BISON_PARSER_H

#ifndef YYSTYPE
typedef union {
unsigned long lval;
double dval;
float fval;
char *sval;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	TOK_FNORD	257
# define	TOK_FILE	258
# define	TOK_APPINFO	259
# define	TOK_SORTINFO	260
# define	TOK_RECORD	261
# define	TOK_BEGIN	262
# define	TOK_END	263
# define	TOK_USER_ERROR	264
# define	TOK_USER_WARNING	265
# define	TOK_USER_MESSAGE	266
# define	TOK_FILENAME	267
# define	TOK_ATTRIB	268
# define	TOK_VERSION	269
# define	TOK_CREATION_DATE	270
# define	TOK_MODIFICATION_DATE	271
# define	TOK_BACKUP_DATE	272
# define	TOK_MODIFICATION	273
# define	TOK_TYPEID	274
# define	TOK_CREATORID	275
# define	TOK_UNIQUEID_SEED	276
# define	TOK_RESOURCE	277
# define	TOK_READONLY	278
# define	TOK_DIRTY	279
# define	TOK_BACKUP	280
# define	TOK_NEWER	281
# define	TOK_RESET	282
# define	TOK_NOBEAM	283
# define	TOK_STREAM	284
# define	TOK_HIDDEN	285
# define	TOK_NOW	286
# define	TOK_TODAY	287
# define	TOK_RECORDID	288
# define	TOK_ID	289
# define	TOK_SECRET	290
# define	TOK_BUSY	291
# define	TOK_DELETE	292
# define	TOK_CATEGORY	293
# define	TOK_BIN	294
# define	TOK_OCT	295
# define	TOK_DEC	296
# define	TOK_HEX	297
# define	TOK_BASE	298
# define	TOK_BYTE	299
# define	TOK_WORD	300
# define	TOK_LONG	301
# define	TOK_SIZE	302
# define	TOK_PADSTRING	303
# define	TOK_PADCHAR	304
# define	TOK_DOUBLE	305
# define	TOK_FLOAT	306
# define	TOK_SIGNED	307
# define	TOK_UNSIGNED	308
# define	TOK_OP_EQUAL	309
# define	TOK_OP_UNEQUAL	310
# define	TOK_OP_LT	311
# define	TOK_OP_LE	312
# define	TOK_OP_GT	313
# define	TOK_OP_GE	314
# define	TOK_OP_SHL	315
# define	TOK_OP_SHR	316
# define	TOK_MAYBE_HEXNUMBER	317
# define	TOK_REALNUMBER	318
# define	TOK_DOUBLENUMBER	319
# define	TOK_FLOATNUMBER	320
# define	TOK_BINNUMBER	321
# define	TOK_OCTNUMBER	322
# define	TOK_DECNUMBER	323
# define	TOK_HEXNUMBER	324
# define	TOK_STRING	325
# define	TOK_CHAR	326
# define	TOK_DATE	327


extern YYSTYPE yylval;

#endif /* not BISON_PARSER_H */